﻿var jHistoryHelper = jHistoryHelper || {
	/*Helper Funktion: Check Link, is Ancor*/
	isHash :  function (url) {
			return (url.indexOf("#") == 0) ? true : false;
			},
	
	/*Helper Funtion: Check Link, if external url
	 * http://stackoverflow.com/questions/6238351/fastest-way-to-detect-external-urls
	 * */
	isExternal : function (url) {
				var match = url.match(/^([^:\/?#]+:)?(?:\/\/([^\/?#]*))?([^?#]+)?(\?[^#]*)?(#.*)?/);
				if (typeof match[1] === "string" && match[1].length > 0 && match[1].toLowerCase() !== window.location.protocol) {
				return true;
				}
				if (typeof match[2] === "string" && match[2].length > 0 && match[2].replace(new RegExp(":(" + {"http:": 80, "https:": 443}[window.location.protocol] + ")?$"), "") !== window.location.host) {
				return true;
				}
				return false;
				},
				
	/*Get Absolute Url
	 * http://stackoverflow.com/questions/470832/getting-an-absolute-url-from-a-relative-one-ie6-issue
	 * */
	toAbsoluteURL : function (url) {
					  // Handle absolute URLs (with protocol-relative prefix)
					  // Example: //domain.com/file.png
					  if (url.search(/^\/\//) != -1) {
					    return window.location.protocol + url
					  }

					  // Handle absolute URLs (with explicit origin)
					  // Example: http://domain.com/file.png
					  if (url.search(/:\/\//) != -1) {
					    return url
					  }

					  // Handle absolute URLs (without explicit origin)
					  // Example: /file.png
					  if (url.search(/^\//) != -1) {
					    return window.location.origin + url
					  }

					  // Handle relative URLs
					  // Example: file.png
					  var base = window.location.href.match(/(.*\/)/)[0]
					  return base + url
				},
						
	/*Check if Browser PushState enable*/
	supportsHistoryPushState : function () {
		//return false;
	    return ("pushState" in window.history) && window.history.pushState !== null;
	},
	
	/* Set Url from Parameter in Browser */
	setUrl : function (url) {
		
		if (jHistoryHelper.supportsHistoryPushState()) {
	    	if (jHistoryHelper.toAbsoluteURL(url) != jHistoryHelper.toAbsoluteURL(jHistoryHelper.getUrl())){
	    		window.history.pushState("", "", url);
	    	}
	    } else {
	        document.location.hash = url;
	    }
	},
	
	/* Get Url from Browser */
	getUrl : function () {
	    if (jHistoryHelper.supportsHistoryPushState()) {
	        return document.location.pathname;
	    } else {
	    	var current = document.location.hash;
	    	if(current.length > 0 && current.substring(0,1) == "#"){current = current.substring(1,current.length)}
	        return current;
	    }
	},
}

var jHistory = function(_options){
	
	var options = {elementSelector : ['#body'],
				maxStackSize : 20,
				maxCacheSize : 1,
				InitFormHandling : true,
				setTitle: true,
				enableDebug: false,
				enableHashFallback: true,
				ajaxHeader: {'jHistory':'jHistory'},
				fnOnStart: {duration: 0,
							render: function (url, container) {
										$(document).scrollTop(0);
									}
							},
				fnOnLoad: {duration: 0,
					render: function (url, selectors, content) {
								$(selectors).each(function(i, selector){
									$(selector).html(content.find(selector).html());
								});
							}
					},
					
	},
	stack = [],
	CurrentUrl = '',
	cache = {},
	consl = (window.console || false),
	
	fnOnStartEnd = true,
	fnOnLoadEnd = true,
	
	/* Add url to History Stack */
	AddToStack = function(url){
	    if (stack.length > 0){if(stack[stack.length -1] != url){stack.push(url);}}
	    else {stack.push(url);}
	    
	    if (stack.length > options.maxStackSize){stack.shift();}
	},
	
	/*Check if Browser url like shown Content and navigate*/
	onHistoryChanged = function () {
	    if (jHistoryHelper.supportsHistoryPushState()) {
	        if(CurrentUrl != jHistoryHelper.getUrl()){
	        	navigate(jHistoryHelper.getUrl());
	        }
	    } else {
	    	 if (CurrentUrl !== jHistoryHelper.getUrl()) {
	    		 navigate(jHistoryHelper.getUrl());
	    	}
	    }
	},
	
	/*Navigate to url*/
	navigate = function(url, Methode, Data, cacheable){
		if (!fnOnLoadEnd){setTimeout(function(){navigate(url, Methode, Data);},100);  return;}
		
		if(options.enableDebug && consl){console.log("fnOnStart: " + url)};
		
		options.fnOnStart.render(url, options.elementSelector);
		fnOnStartEnd = false;
		setTimeout(function(){fnOnStartEnd = true;}, options.fnOnStart.duration);

		
		jHistoryHelper.setUrl(url);
        CurrentUrl = url;
		AddToStack(url);
		
		if (typeof Methode == 'undefined' || Methode == null) {Methode = 'GET';}
		if (typeof cacheable == 'undefined') {cacheable = true;}
		
		if (cache[url] && cacheable){
			if(options.enableDebug && consl){console.log("Load From Cache: " + url)};
			Load(url, cache[url]);
		} else {
			$.ajax({
				url: url,
				dataType: 'html',
				type: Methode,
				data: Data,
				 headers: options.ajaxHeader,
				success: function(res){
					if (options.maxCacheSize > 0 && cacheable){
						cache[url] = res;
						if (cache.length > options.maxStackSize){cache.shift();}
					}
					Load(url, res);
				},
				error: function(status){
					Load(url, status.responseText);
				}
				});
		}
	},
	
	/*Load Content in Container*/
	Load = function(url, content){
		
		if (!fnOnStartEnd){setTimeout(function(){Load(url, content);},100);  return;}
		
		var wrapper = $("<div></div>");
		wrapper.html(content);
		
		if(options.enableDebug && consl){console.log("fnOnLoad: " + url)};
		options.fnOnLoad.render(url, options.elementSelector, wrapper);
		fnOnLoadEnd = false;
		setTimeout(function(){fnOnLoadEnd = true;}, options.fnOnLoad.duration);
		
		if(options.setTitle){$("title").text(wrapper.find("title").text())};
		if(options.InitFormHandling){InitFormHandling();}
	},
	
	/*Init Link Click Events*/
	InitLinkHandling = function(){
		
		   $(document).on("click","a", function(event) {
		   	
		   	if($(event.currentTarget).attr("href")){
		   		var url = $(event.currentTarget).attr("href");
		   		if (!jHistoryHelper.isExternal(url) && !jHistoryHelper.isHash(url)){
		   			var cacheable = true;
		   			if ($(event.currentTarget).attr("jhistory") && $(event.currentTarget).attr("jhistory") == "no-cache") {cacheable = false;}
		   			if ($(event.currentTarget).attr("jhistory") && $(event.currentTarget).attr("jhistory") == "no") {return true;}
		   			event.preventDefault();
		   			navigate($(event.currentTarget).attr("href"),null,null, cacheable);
		   	   		return false;
		   		}
		   	}

		   	return true;
		   }); 
			
		},
	
	/*Init Form Sublit Event*/
	InitFormHandling = function(){
			if(options.enableDebug && consl){console.log("InitFormHandling")};
			
			$("form").submit(function(){
				if ($(this).attr("jhistory") && $(this).attr("jhistory") == "no") {return true;}
				
				var Acion = CurrentUrl;
				if ($(this).attr("action")){
					Acion = $(this).attr("action");
				}
				
				var Data = $(this).serialize();
				var Methode = 'POST';
				if ($(this).attr("method")){
					Methode = $(this).attr("method");
				}
					
				navigate(Acion, Methode, Data, false);
				return false;
			});
			
		},
		
		/*Init this Function*/
		initialize = function () {
			if (!jHistoryHelper.supportsHistoryPushState() && !options.enableHashFallback){return;}
			
				    if (jHistoryHelper.supportsHistoryPushState()) {
				        $(window).bind("popstate", onHistoryChanged);
				    } else {
				        hashCheckInterval = setInterval(onHistoryChanged, 200);
				    }
				    
				    InitLinkHandling();
				    if(options.InitFormHandling){InitFormHandling();}
				};
		
		/*Publick function: Navigate in History back*/
		this.NavigateBack = function(){
			var path = ""; 
			if (stack.length > 0){stack.pop();} //remove current Page
			if (stack.length > 0){path = stack[stack.length -1];} //get lastPage and remove
			navigate(path);
		};

        this.reload = function(){
            navigate(CurrentUrl, null, null, false);
        }
			
	options = $.extend( {}, options, _options );
	initialize();
}